//+--------------------------------------------------------------------------------------------+
//|                                                                                    KRI.mq4 |
//|                                                                 Kairi Relative Index (KRI) |
//|                                                             Copyright  2011, Serega Lykov |
//|                                                                 http://mtexperts.narod.ru/ |
//+--------------------------------------------------------------------------------------------+

#property copyright "Copyright  2011, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"

//----   --------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Gold

//----   ----------------------------------------------------------------------+
extern int    MA_Period                   = 14;
extern int    MA_Method                   = 0;
extern int    MA_Price                    = 0;

//----  --------------------------------------------------------------------------------+
static double KRI[];
static double MA[];

//-----   -----------------------------------------------------------------+

//---------------------------------------------------------------------------------------------+
//----   ---------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int init()
  {
   if(MA_Method < 0 || MA_Method > 3) MA_Method = 0;
   //----  ""   ----------------------------------------------+
   IndicatorShortName(StringConcatenate("KRI(",GetStringMAMethod(MA_Method),"(",DoubleToStr(MA_Period,0),"))"));
   //---- 1   -------------------------------------------------------------+
   IndicatorBuffers(2);
   //----     ----------------------------------------------+
   IndicatorDigits(4);
   //----     ----------------------------------------------------+
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   //----      ---------------------------------------------+
   SetIndexBuffer(0,KRI);
   SetIndexBuffer(1,MA);
   //----     --------------------------------------------------------+
   SetIndexLabel(0,StringConcatenate("KRI(",DoubleToStr(MA_Period,0),")"));
   //----       --------------------------------+
   SetIndexDrawBegin(0,MA_Period);
   //----    --------------------------------------------------------+
   SetLevelValue(0,0.0);
   SetLevelStyle(STYLE_DOT,1,White);
   //----   -----------------------------------------------------------------+
   return(0);
   Print("---- Programming by Serega Lykov, http://mtexperts.narod.ru/ ----");
  }

//---------------------------------------------------------------------------------------------+
//----   -------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//---------------------------------------------------------------------------------------------+
//----   ---------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int start()
  {
   //----        --------------------+
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   //----      ------------------------------------------+
   if(counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   //----   MA ----------------------------------------------------------------+
   for(int i=limit; i>=0; i--) MA[i] = iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i);
   //----   KRI --------------------------------------------------------------+
   for(i=limit; i>=0; i--)
     {
      if(MA[i] == 0.0) KRI[i] = EMPTY_VALUE;
      else KRI[i] = (Close[i] - MA[i]) / MA[i] * 100.0;
     }
   //----   -----------------------------------------------------------------+
   return(0);
  }
    
//---------------------------------------------------------------------------------------------+
//---- GetStringMAMethod ----------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string GetStringMAMethod(int ma_method)
  {
   switch(ma_method)
     {
      case 1:  string str_ma_method = "EMA";  break;
      case 2:         str_ma_method = "SMMA"; break;
      case 3:         str_ma_method = "LWMA"; break;
      default:        str_ma_method = "SMA";
     }
   return(str_ma_method);
  }
 
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+